S4000/ 	ORG	$
 ;	S4000/ASM
 ;
 ;  CONTAINS ALL RESERVED RAM SPACE
 COMST	EQU	37DEH	;COMMUNICATION STATUS
 COMDAT	EQU	37DFH	;COMMUNICATION DATA
 ILATCH	EQU	37E0H	;INTERRUPT LATCH
 DDSEL	EQU	37E1H	;DISK DRIVE SELECT
 CASEL	EQU	37E4H	;CASSETTE SELECT
 LPRT	EQU	37E8H	;LINEPRINTER
 FDC	EQU	37ECH	;FLOPPY-DISK CONTROLLER
 TRACK	EQU	37EDH	;FDC TRACK REGISTER
 SECTOR	EQU	37EEH	;FDC SECTOR REGISTER
 STATUS	EQU	37EFH	;FDC STATUS & TRACK SEEK REGISTER
 RST8	JP	1C96H		;COMPARE (HL) ((SP))
 RST10H	JP	1D78H		;PASS THROUGH STRING
 RST18H	JP	1C90H		;COMPARE HL-DE
 RST20H	JP	25D9H		;CHECK NTF
 RST28H	JP	OVERLAY		;BRING IN OVERLAY & JUMP
 RST30H	JP	GETDEBUG
 RST38H	JP	TASK		;INTERRUPT SERVICE
 ;
 ;	CONTROL BLOCKS SET AS FOLLOWS
 ;  DCB TYPE = 0 IF NON-ACTIVE
 ;  DCB TYPE = 1 ACTIVE OUTPUT, -1 ACTIVE INPUT
 ;  DCB TYPE = * IF ACTIVE AND SET TO ANOTHER BLOCK
 ;  ADDRESS  = 2 BYTE DRIVER ADDRESS
 ;  ADDRESS  = DEVICE NAME IF DCB TYPE = *
 ;
 ;	KEYBOARD DEVICE CONTROL BLOCK
 INDCB	DB	1	;KEYBOARD DCB TYPE, INPUT
 KIADDR	DW	LINKER	;DRIVER ADDRESS
 KIFLAG	DB	0	;KEYBOARD STATUS FLAG
 ;BIT 7 = GRAPHICS OFF/ON
 ;BIT 6 =
 ;BIT 5 =
 ;BIT 4 =
 ;BIT 3 =
 ;BIT 2 =
 ;BIT 1 = AUTO REPEAT OFF/ON
 ;BIT 0 = UPPER/LOWER CASE
 KICOUNT	DB	12H	;DELAY TIME B4 1'ST REPEAT
 RPCOUNT	DB	0	;DELAY COUNTER
 	DM	'KI'	;DEVICE NAME
 ;	DISPLAY DEVICE CONTROL BLOCK
 OUTDCB	DB	2	;DISPLAY DCB TYPE, OUTPUT
 DOADDR	DW	LINKER	;DRIVER ADDRESS
 CURSOR	DW	3C40H	;CURSOR POSITION
 CHAR	DB	0B0H	;CURSOR CHARACTER
 	DM	'DO'	;DEVICE NAME
 ;	PRINTER DEVICE CONTROL BLOCK
 PRDCB	DB	2	;PRINTER DCB TYPE,OUTPUT
 PRADD	DW	POUT	;DRIVER ADDRESS
 LINEPG	DB	66	;LINES/PAGE
 COUNT	DB	0	;LINE COUNTER
 PRFLAG	DB	0	;PRINTER CONDITION
 ;BIT 7 = WILL PRINT GRAPHICS
 ;BIT 6 =
 ;BIT 5 =
 ;BIT 4 =
 ;BIT 3 =
 ;BIT 2 =
 ;BIT 1 =
 ;BIT 0 =
 	DM	'PR'	;DEVICE NAME
 	JP	DOSRDY		;GO DOS READY
 	JP	NONDOS		;NON DOS ERROR EXIT
 	JP	0		;INTERPRET COMMAND
 KYBRD	DW	0	;KEYBOARD WORK AREA
 	DW	0	; FOR 7 BYTES
 	DW	0	;  "
 	DB	0	;  "
 PSIZE	DB	0	;PRINT SIZE FLAG 0=64, 8=32
 	DB	1	;RELEASE NUMBER
 BASE	DB	10	;DEFAULT NUMBER ENTRY BASE
 ;	TIME STORAGE AREA
 TICKS	DB	0	;COUNT TO 40 FOR 1 SECOND
 SECOND	DB	0	;SECONDS
 MINUTE	DB	0	;MINUTES
 HOUR	DB	0	;HOURS
 YEAR	DB	0	;YEAR
 DAY	DB	0	;DAY
 MONTH	DB	0	;MONTH
 	DW	0	;BEGIN BASIC
 TOPMEM	DW	0	;TOP OF AVAILABLE MEMORY
 	DW	0	;TOP OF VIDEO
 	DW	0	;BOTTOM OF VIDEO
 NEXT	DB	0	;interrupt key count
 LAST	DB	00H	;LAST DOS COMMAND
 	DEFS	1AFH
 STACK	EQU	$
 IOBUFF	DB	0	;I/O BUFFER
 	DS	255	; FOR 256 BYTES
 	END
 OF AVAILABLE MEMORY
 	DW	0	;TOP OF VIDEO
 	DW	0	;BOTTOM OF VIDEO
 NEXT	DB	0	;interrupt key count
ETTKS
 	JP	GETTYPE
 IOBUFF	DB	0	;I/O BUFFER
 	DS	255	; FOR 256 BYTES
 	END
ELECT
 	JP	INPUT
 	JP	DOSINT
 